local _, addon = ...

local CreateFromMixins = CreateFromMixins

local proxies = { }

function addon.GetProxy(target)
	assert(target)
	return proxies[target]
end

function addon.AddProxy(target, mixin, initFunction, ...)
	assert(mixin)
	if (target and not proxies[target]) then
		local proxy = CreateFromMixins(mixin)
		proxy.target = target
		proxies[target] = proxy
		if (initFunction) then
			if (type(initFunction) == "function") then
				initFunction(proxy, ...)
			elseif (type(initFunction) == "string") then
				proxy[initFunction](proxy, ...)
			end
		end
	end
end
